﻿SliceCommander = LibStub("AceAddon-3.0"):NewAddon("SliceCommander", "AceEvent-3.0")
local self = SliceCommander
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfig = LibStub("AceConfig-3.0")

SC = { }
SC.VERSION = GetAddOnMetadata("SliceCommander", "Version")
SC.BARS = { 
	['THREAT'] = {
		['obj'] = 0,
		['expire'] = 0
	},
	['KS'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_KS,
		['type'] = 2
	},
	['CS'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_CS,
		['type'] = 2
	},
	['CP'] = {
		['obj'] = 0,
		['expire'] = 0,
		['target'] = ''
	},
	['VEN'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_VEN,
		['type'] = 2
	},
	['VENCD'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_VEN,
		['type'] = 2
	},
	['ToT'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_TOT,
		['type'] = 1
	},
	['SnD'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_SND,
		['type'] = 1
	},
	['DP'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_DP,
		['type'] = 2,
		['count'] = 0
	},
	['ENV'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_ENV,
		['type'] = 1
	},
	['REC'] = {
		['obj'] = 0,
		['expire'] = 0,
		['tick'] = {
			['obj'] = {},
			['expire'] = {}
		},
		['name'] = SC_SPELL_REC,
		['type'] = 1
	},
	['Rup'] = {
		['obj'] = 0,
		['expire'] = 0,
		['tick'] = {
			['obj'] = {},
			['expire'] = {},
			['value'] = 2
		},
		['name'] = SC_SPELL_RUP,
		['type'] = 2
	},
	['Gar'] = {
		['obj'] = 0,
		['expire'] = 0,
		['tick'] = {
			['obj'] = {},
			['expire'] = {},
			['value'] = 3
		},
		['name'] = SC_SPELL_GAR,
		['type'] = 2
	},
	['MH'] = {
		['obj'] = 0,
		['expire'] = 0
	},
	['OH'] = {
		['obj'] = 0,
		['expire'] = 0
	},
	['AR'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_AR,
		['type'] = 1,
	},
	['ARCD'] = {
		['obj'] = 0,
		['expire'] = 0,
		['name'] = SC_SPELL_AR,
		['type'] = 1,
	},
	['BF'] = {
		['icon'] = 0,
		['name'] = SC_SPELL_BF,
		['type'] = 1
	},
}

function self:TestValueOptions()
	if SliceCommander_Save == nil then
		return true
	end
	SliceCommander_Save.ARSound = 'Mario'
	SliceCommander_Save.ARSound_Glyphed = 'Mario glyphed'
	if SliceCommander_Save.IsLocked == nil or
	SliceCommander_Save.HideEnergy == nil or
	SliceCommander_Save.Energy1 == nil or
	SliceCommander_Save.Energy2 == nil or
	SliceCommander_Save.Energy3 == nil or
	SliceCommander_Save.Fail == nil or
	SliceCommander_Save.Expire == nil or
	SliceCommander_Save.Tick3 == nil or
	SliceCommander_Save.Tick2 == nil or
	SliceCommander_Save.Tick1 == nil or
	SliceCommander_Save.Applied == nil or
	SliceCommander_Save.Apply3 == nil or
	SliceCommander_Save.Apply2 == nil or
	SliceCommander_Save.Apply1 == nil or
	SliceCommander_Save.EnergySound1 == nil or
	SliceCommander_Save.EnergySound2 == nil or
	SliceCommander_Save.EnergySound3 == nil or
	SliceCommander_Save.HealthUnder == nil or
	SliceCommander_Save.RUP_Fail == nil or
	SliceCommander_Save.RUP_Expire == nil or
	SliceCommander_Save.RUP_Applied == nil or
	SliceCommander_Save.RUP_Refresh3 == nil or
	SliceCommander_Save.RUP_Refresh2 == nil or
	SliceCommander_Save.RUP_Refresh1 == nil or
	SliceCommander_Save.RUP_Alert == nil or
	SliceCommander_Save.Width == nil or
	SliceCommander_Save.Scale == nil or
	SliceCommander_Save.PadLatency == nil or
	SliceCommander_Save.SpellText == nil or
	SliceCommander_Save.FullTimer == nil or
	SliceCommander_Save.SoundCombat == nil or
	SliceCommander_Save.EnergyTrans == nil or
	SliceCommander_Save.BarMargin == nil or
	SliceCommander_Save.DPBarShow == nil or
	SliceCommander_Save.EnvenomShow == nil or
	SliceCommander_Save.PoisonShow == nil or
	SliceCommander_Save.PoisonTransparencyShow == nil or
	SliceCommander_Save.SnDBarShow == nil or
	SliceCommander_Save.VenBarShow == nil or
	SliceCommander_Save.RECBarShow == nil or
	SliceCommander_Save.KSBarShow == nil or
	SliceCommander_Save.CSBarShow == nil or
	SliceCommander_Save.TotTBarShow == nil or
	SliceCommander_Save.RupBarShow == nil or
	SliceCommander_Save.GarBarShow == nil or
	SliceCommander_Save.THREATBarShow == nil or
	SliceCommander_Save.ARBarShow == nil or
	SliceCommander_Save.ShowARCD == nil or
	SliceCommander_Save.BFBarShow == nil or
	SliceCommander_Save.checkHealthSpec1 == nil or
	SliceCommander_Save.checkHealthSpec2 == nil or
	SliceCommander_Save.CPBarShow == nil or
	SliceCommander_Save.ThreatGroupOnly == nil or
	SliceCommander_Save.EnergyHeight == nil or
	SliceCommander_Save.TimerHeight == nil or
	SliceCommander_Save.BarTexture == nil or
	SliceCommander_Save.PosCP == nil or
	SliceCommander_Save.PosThreat == nil or
	SliceCommander_Save.PosKS == nil or
	SliceCommander_Save.PosCS == nil or
	SliceCommander_Save.PosREC == nil or
	SliceCommander_Save.PosSND == nil or
	SliceCommander_Save.PosRUP == nil or
	SliceCommander_Save.PosGAR == nil or
	SliceCommander_Save.PosTOT == nil or
	SliceCommander_Save.PosVEN == nil or
	SliceCommander_Save.PosDP == nil or
	SliceCommander_Save.PosENV == nil or
	SliceCommander_Save.FrameOpacity == nil or
	SliceCommander_Save.PosAR == nil or
	SliceCommander_Save.PosBF == nil or
	SliceCommander_Save.ARMarioMod == nil
	then
		return true
	end
	return false	
end

function self:SetDefaultOptions()
	SliceCommander_Save = {}
	SliceCommander_Save.ARSound = 'Mario'
	SliceCommander_Save.ARSound_Glyphed = 'Mario glyphed'
	SliceCommander_Save.IsLocked = true
	SliceCommander_Save.HideEnergy = false
	SliceCommander_Save.Energy1 = 35
	SliceCommander_Save.Energy2 = 55
	SliceCommander_Save.Energy3 = 25
	SliceCommander_Save.Fail = 'None'
	SliceCommander_Save.Expire = 'None'
	SliceCommander_Save.Tick3 = 'None'
	SliceCommander_Save.Tick2 = 'None'
	SliceCommander_Save.Tick1 = 'None'
	SliceCommander_Save.Applied = 'None'
	SliceCommander_Save.Apply3 = 'None'
	SliceCommander_Save.Apply2 = 'None'
	SliceCommander_Save.Apply1 = 'None'
	SliceCommander_Save.EnergySound1 = 'None'
	SliceCommander_Save.EnergySound2 = 'None'
	SliceCommander_Save.EnergySound3 = 'None'
	SliceCommander_Save.HealthUnder = 'You Spin Me'
	SliceCommander_Save.RUP_Fail = 'None'
	SliceCommander_Save.RUP_Expire = 'None'
	SliceCommander_Save.RUP_Applied = 'None'
	SliceCommander_Save.RUP_Refresh3 = 'None'
	SliceCommander_Save.RUP_Refresh2 = 'None'
	SliceCommander_Save.RUP_Refresh1 = 'None'
	SliceCommander_Save.RUP_Alert = 'None'
	SliceCommander_Save.Width = 280
	SliceCommander_Save.Scale = 100
	SliceCommander_Save.PadLatency = true
	SliceCommander_Save.SpellText = true
	SliceCommander_Save.FullTimer = false
	SliceCommander_Save.SoundCombat = true
	SliceCommander_Save.EnergyTrans = 0
	SliceCommander_Save.BarMargin = 3
	SliceCommander_Save.DPBarShow = false
	SliceCommander_Save.EnvenomShow = true
	SliceCommander_Save.PoisonShow = true
	SliceCommander_Save.PoisonTransparencyShow = true
	SliceCommander_Save.SnDBarShow = true
	SliceCommander_Save.VenBarShow = true
	SliceCommander_Save.RECBarShow = true
	SliceCommander_Save.KSBarShow = true
	SliceCommander_Save.CSBarShow = true
	SliceCommander_Save.TotTBarShow = true
	SliceCommander_Save.RupBarShow = true
	SliceCommander_Save.GarBarShow = true
	SliceCommander_Save.THREATBarShow = true
	SliceCommander_Save.ARBarShow = true
	SliceCommander_Save.ShowARCD = true
	SliceCommander_Save.BFBarShow = true
	SliceCommander_Save.checkHealthSpec1 = true
	SliceCommander_Save.checkHealthSpec2 = true
	SliceCommander_Save.CPBarShow = true
	SliceCommander_Save.ThreatGroupOnly = true
	SliceCommander_Save.EnergyHeight = 28
	SliceCommander_Save.TimerHeight = 17
	SliceCommander_Save.BarTexture = 'Blizzard'
	SliceCommander_Save.PosCP = -1
	SliceCommander_Save.PosThreat = -2
	SliceCommander_Save.PosCS = -3
	SliceCommander_Save.PosKS = -4
	SliceCommander_Save.PosREC = 1
	SliceCommander_Save.PosSND = 2
	SliceCommander_Save.PosRUP = 3
	SliceCommander_Save.PosGAR = 4
	SliceCommander_Save.PosTOT = 5
	SliceCommander_Save.PosVEN = 6
	SliceCommander_Save.PosDP = 7
	SliceCommander_Save.PosENV = 8
	SliceCommander_Save.PosAR = 9
	SliceCommander_Save.PosBF = 10
	SliceCommander_Save.FrameOpacity = 100
	SliceCommander_Save.ARMarioMod = false
	if SC.BARS['SnD']['obj'] ~= 0 then
		SliceCommander:ApplyConf()
		LibStub("AceConfigRegistry-3.0"):NotifyChange("SliceCommander")
	end
end

function SliceCommander:ApplyConf()
	SliceCommander:LockCkecked(SliceCommander_Save.IsLocked)
	SliceCommander:SetTimersHeight(SliceCommander_Save.TimerHeight)
	SliceCommander:SetWidth(SliceCommander_Save.Width)
	SliceCommander:SetEnergyHeight(SliceCommander_Save.EnergyHeight)
	SliceCommander:SetScale(SliceCommander_Save.Scale)
	SliceCommander:Config_RetextureBars(SliceCommander:BarTexture())
	SliceCommander:FrameOpacity(SliceCommander_Save.FrameOpacity)
	SliceCommander:SetPoisonTransparency(SliceCommander_Save.EnergyTrans)
end

function self:ConfigSoundMenuInit(WhichMenu)
	returnArray = {}
	for ignore, SoundName in pairs(SliceCommander_SoundMenu[WhichMenu]) do   
		returnArray[SoundName] = SoundName
	end
	return returnArray
end

SC_OptionsTable_Sound = {
	name = SC_LANG_SOUND,
	handler = SliceCommander,
	type = "group",
	args = {--Sound settings
		headerSndSoundSetting = {--Slice and Dice
			order = 1,
			name = "Slice and Dice",
			type = "header"
		},
		Tick3 = {--Alert - 3 sec
			order = 2,
			name = "Alert - 3 sec",
			desc = "Alert 3 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick3 = val
			end,
			get = function(info) return SliceCommander_Save.Tick3 end
		},
		Tick2 = {--Alert - 2 sec
			order = 4,
			name = "Alert - 2 sec",
			desc = "Alert 2 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick2 = val
			end,
			get = function(info) return SliceCommander_Save.Tick2 end
		},
		Tick1 = {--Alert - 1 sec
			order = 6,
			name = "Alert - 1 sec",
			desc = "Alert 1 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Tick1 = val
			end,
			get = function(info) return SliceCommander_Save.Tick1 end
		},
		Apply3 = {--Refresh - 3 sec
			order = 3,
			name = "Refresh - 3 sec",
			desc = "Refresh 3 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply3 = val
			end,
			get = function(info) return SliceCommander_Save.Apply3 end
		},
		Apply2 = {--Refresh - 2 sec
			order = 5,
			name = "Refresh - 2 sec",
			desc = "Refresh 2 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply2 = val
			end,
			get = function(info) return SliceCommander_Save.Apply2 end
		},
		Apply1 = {--Refresh - 1 sec
			order = 7,
			name = "Refresh - 1 sec",
			desc = "Refresh 1 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Apply1 = val
			end,
			get = function(info) return SliceCommander_Save.Apply1 end
		},
		Fail = {--Faillure
			order = 8,
			name = "Faillure",
			desc = "The refresh failled",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Fail = val
			end,
			get = function(info) return SliceCommander_Save.Fail end
		},
		
		Applied = {--Applied
			order = 9,
			name = "Applied",
			desc = "Slice and Dice is applied",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Applied = val
			end,
			get = function(info) return SliceCommander_Save.Applied end
		},
		Expire = {--Expire
			order = 10,
			name = "Expired",
			desc = "Slice and Dice buff expire",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.Expire = val
			end,
			get = function(info) return SliceCommander_Save.Expire end
		},
		headerRupSoundSetting = {--Rupture
			order = 11,
			name = "Rupture",
			type = "header"
		},
		RUP_Alert = {--Alert
			order = 12,
			name = "Alert",
			desc = "Alert 3, 2 and 1 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Tick")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Alert = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Alert end
		},
		RUP_Refresh3 = {--Refresh - 3 sec
			order = 13,
			name = "Refresh - 3 sec",
			desc = "Refresh 3 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh3 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh3 end
		},
		RUP_Refresh2 = {--Refresh - 2 sec
			order = 15,
			name = "Refresh - 2 sec",
			desc = "Refresh 2 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh2 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh2 end
		},
		RUP_Refresh1 = {--Refresh - 1 sec
			order = 17,
			name = "Refresh - 1 sec",
			desc = "Refresh 1 secondes before fade",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Refresh1 = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Refresh1 end
		},
		RUP_Fail = {--Faillure
			order = 14,
			name = "Faillure",
			desc = "The refresh failled",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Fail = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Fail end
		},
		RUP_Applied = {--Applied
			order = 16,
			name = "Applied",
			desc = "Rupture is applied",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Apply")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Applied = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Applied end
		},
		RUP_Expire = {--Expire
			order = 18,
			name = "Expired",
			desc = "Rupture debuff expire",
			type = "select",
			values = function()
				return self:ConfigSoundMenuInit("Fail")
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.RUP_Expire = val
			end,
			get = function(info) return SliceCommander_Save.RUP_Expire end
		},
	}
}

SC_OptionsTable_DisplayTimer = {
	name = SC_DISPLAY_SETTINGS,
	handler = SliceCommander,
	type = "group",
	args = {--Display setting
		displayDescription = {
			order = 0,
			name = "Each bar have to have a different position. If you want to have a bar on the top of the energy bar you have to use negative index. Positive index is used to position bar at the bottom.",
			fontSize = "medium",
			type = "description"
		},
		headerEnergySetting = {--Combo Point Settings
			order = 1,
			name = "Energy bar Settings",
			type = "header"
		},
		HideEnergy = {--Hide Energy
			order = 2,
			name = "Hide Energy bar",
			desc = "Hide the Energy bar",
			type = "toggle",
			set = function(info,val)
				if val then
					VTimerEnergy:Hide()
				else
					VTimerEnergy:Show()
				end
				SliceCommander_Save.HideEnergy = val
			end,
			get = function(info) return SliceCommander_Save.HideEnergy end
		},
		EnergyTrans = {--Energy bar transparancy
			order = 3,
			name = "Transparency (Full)",
			desc = "The fade out value of the energy bar when it is full.",
			type = "range",
			min = 0,
			max = 100,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander:SetPoisonTransparency(val)
				SliceCommander_Save.EnergyTrans = val
			end,
			get = function(info) return SliceCommander_Save.EnergyTrans end,
			isPercent = false
		},
		Energy1 = {--Energy Marker 1
			order = 4,
			name = "Energy Marker 1",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy1 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy1 end,
			isPercent = false
		},
		Energy2 = {--Energy Marker 2
			order = 5,
			name = "Energy Marker 2",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy2 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy2 end,
			isPercent = false
		},
		Energy3 = {--Energy Marker 3
			order = 6,
			name = "Energy Marker 3",
			type = "range",
			min = 0,
			max = 120,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				if val > UnitManaMax("player") then
					val = UnitManaMax("player")
				end
				SliceCommander_Save.Energy3 = val
				SliceCommander:Config_OtherVars()
			end,
			get = function(info) return SliceCommander_Save.Energy3 end,
			isPercent = false
		},
		headerDPSetting = {--Poison bar Settings
			order = 7,
			name = "Poison bar Settings",
			type = "header"
		},
		DPBarShow = {--Show Poison
			order = 8,
			name = "Show Poison bar",
			desc = "Display the Poison timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.DPBarShow = val
			end,
			get = function(info) return SliceCommander_Save.DPBarShow end
		},
		PosDP = {--Poison position
			order = 9,
			name = "Poison bar position",
			desc = "The place where to display the Poison bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosDP = val
			end,
			get = function(info) return SliceCommander_Save.PosDP end
		},
		EnvenomShow = {--Show Envenom
			order = 10,
			name = "Show envenom buff",
			desc = "The timer bar in default will display the timer of deadly poison on the target.",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.EnvenomShow = val
			end,
			get = function(info) return SliceCommander_Save.EnvenomShow end
		},
		PosENV = {--Poison position
			order = 9,
			name = "Envenom bar position",
			desc = "The place where to display the Envenom bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosENV = val
			end,
			get = function(info) return SliceCommander_Save.PosENV end
		},
		PoisonShow = {--Show Poison weapon enchant
			order = 11,
			name = "Show poison weapon enchant",
			desc = "Display two thin poison bar timer on the energy bar corresponding of each temporary enchant on each weapon.",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.PoisonShow = val
			end,
			get = function(info) return SliceCommander_Save.PoisonShow end
		},
		PoisonTransparencyShow = {--Show Poison weapon enchant
			order = 12,
			name = "Disable energy bar fade out",
			desc = "Disable energy bar and poison bar fade out when poison on weapon(s) is up",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.PoisonTransparencyShow = val
			end,
			get = function(info) return SliceCommander_Save.PoisonTransparencyShow end
		},
		headerVendettaSetting = {--Vendetta Settings
			order = 101,
			name = "Vendetta Settings",
			type = "header"
		},
		VenBarShow = {--Show vendetta
			order = 102,
			name = "Show vendetta bar",
			desc = "Display the vendetta timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.VenBarShow = val
			end,
			get = function(info) return SliceCommander_Save.VenBarShow end
		},
		PosVEN = {--Vendetta position
			order = 103,
			name = "Vendetta bar position",
			desc = "The place where to display the vendetta bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosVEN = val
			end,
			get = function(info) return SliceCommander_Save.PosVEN end
		},
		headerToTSetting = {--Tricks of the Trade Settings
			order = 104,
			name = "Tricks of the Trade Settings",
			type = "header"
		},
		TotTBarShow = {--Show ToT
			order = 105,
			name = "Show Tricks of the Trade bar",
			desc = "Display the Tricks of the Trade timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.TotTBarShow = val
			end,
			get = function(info) return SliceCommander_Save.TotTBarShow end
		},
		PosTOT = {--ToT position
			order = 106,
			name = "Tricks of the Trade bar position",
			desc = "The place where to display the Tricks of the Trade bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosTOT = val
			end,
			get = function(info) return SliceCommander_Save.PosTOT end
		},
		headerRecSetting = {--Recuperate Settings
			order = 110,
			name = "Recuperate Settings",
			type = "header"
		},
		RECBarShow = {--Show Recuperate
			order = 111,
			name = "Show Recuperate bar",
			desc = "Display the Recuperate timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.RECBarShow = val
			end,
			get = function(info) return SliceCommander_Save.RECBarShow end
		},
		PosREC = {--Recuperate position
			order = 112,
			name = "Recuperate bar position",
			desc = "The place where to display the Recuperate bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosREC = val
			end,
			get = function(info) return SliceCommander_Save.PosREC end
		},
		headerKSSetting = {--Stun bar Settings
			order = 113,
			name = "Kidney shot bar Settings",
			type = "header"
		},
		KSBarShow = {--Show Stun
			order = 114,
			name = "Kidney shot bar",
			desc = "Display the Kidney shot timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.KSBarShow = val
			end,
			get = function(info) return SliceCommander_Save.KSBarShow end
		},
		PosKS = {--Stun position
			order = 115,
			name = "Kidney shot bar position",
			desc = "The place where to display the Kidney shot bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosKS = val
			end,
			get = function(info) return SliceCommander_Save.PosKS end
		},
		headerCSSetting = {--Stun bar Settings
			order = 116,
			name = "Cheap shot bar Settings",
			type = "header"
		},
		CSBarShow = {--Show Stun
			order = 117,
			name = "Show Cheap shot bar",
			desc = "Display the Cheap shot timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.CSBarShow = val
			end,
			get = function(info) return SliceCommander_Save.CSBarShow end
		},
		PosCS = {--Stun position
			order = 118,
			name = "Cheap shot bar position",
			desc = "The place where to display the Cheap shot bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosCS = val
			end,
			get = function(info) return SliceCommander_Save.PosCS end
		},
		headerBloodSetting = {--Blood Settings
			order = 121,
			name = "Blood bar Settings",
			type = "header"
		},
		RupBarShow = {--Show Blood
			order = 122,
			name = "Show Rupture bar",
			desc = "Display the Blood timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.RupBarShow = val
			end,
			get = function(info) return SliceCommander_Save.RupBarShow end
		},
		PosRUP = {--Blood position
			order = 123,
			name = "Rupture bar position",
			desc = "The place where to display the Rupture bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosRUP = val
			end,
			get = function(info) return SliceCommander_Save.PosRUP end
		},
		GarBarShow = {--Show Blood
			order = 124,
			name = "Show Garrote bar",
			desc = "Display the Garrote timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.GarBarShow = val
			end,
			get = function(info) return SliceCommander_Save.GarBarShow end
		},
		PosGAR = {--Blood position
			order = 125,
			name = "Garrote bar position",
			desc = "The place where to display the Garrote bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosGAR = val
			end,
			get = function(info) return SliceCommander_Save.PosGAR end
		},
		headerSndSetting = {--Slice and Dice Settings
			order = 126,
			name = "Slice and Dice Settings",
			type = "header"
		},
		SnDBarShow = {--Show Slice and Dice
			order = 127,
			name = "Show Slice and Dice bar",
			desc = "Display the Slice and Dice timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.SnDBarShow = val
			end,
			get = function(info) return SliceCommander_Save.SnDBarShow end
		},
		PosSND = {--Slice and Dice position
			order = 128,
			name = "Slice and Dice bar position",
			desc = "The place where to display the Slice and Dice bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosSND = val
			end,
			get = function(info) return SliceCommander_Save.PosSND end
		},
		headerCPSetting = {--Combo Point Settings
			order = 129,
			name = "Combo Point bar Settings",
			type = "header"
		},
		CPBarShow = {--Show Combo Point
			order = 130,
			name = "Show Combo Point bar",
			desc = "Display the Combo Point timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.CPBarShow = val
			end,
			get = function(info) return SliceCommander_Save.CPBarShow end
		},
		PosCP = {--Combo Point position
			order = 131,
			name = "Combo Point bar position",
			desc = "The place where to display the Combo Point bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosCP = val
			end,
			get = function(info) return SliceCommander_Save.PosCP end
		},
		headerThreatSetting = {--Threat Settings
			order = 132,
			name = "Threat bar Settings",
			type = "header"
		},
		THREATBarShow = {--Show Threat
			order = 133,
			name = "Show Threat bar",
			desc = "Display the Threat bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.THREATBarShow = val
			end,
			get = function(info) return SliceCommander_Save.THREATBarShow end
		},
		PosThreat = {--Threat position
			order = 134,
			name = "Threat bar position",
			desc = "The place where to display the Threat bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosThreat = val
			end,
			get = function(info) return SliceCommander_Save.PosThreat end
		},
		ThreatGroupOnly = {--Show Threat bar only in group
			order = 135,
			name = "Threat bar only in group",
			desc = "Display the Threat bar only if you are in a group or a raid",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ThreatGroupOnly = val
			end,
			get = function(info) return SliceCommander_Save.ThreatGroupOnly end
		},
		headerARSetting = {--Adrenaline rush Settings
			order = 136,
			name = "Adrenaline Rush Settings",
			type = "header"
		},
		ARBarShow = {--Show Adrenaline rush
			order = 137,
			name = "Show Adrenaline Rush bar",
			desc = "Display the Adrenaline rush timer bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ARBarShow = val
			end,
			get = function(info) return SliceCommander_Save.ARBarShow end
		},
		PosAR = {--Adrenaline rush position
			order = 138,
			name = "Adrenaline rush bar position",
			desc = "The place where to display the Adrenaline rush bar",
			type = "select",
			values = function()
				returnArray = {}
				for key = -15, 15, 1 do
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.PosAR = val
			end,
			get = function(info) return SliceCommander_Save.PosAR end
		},
		ARCDBarShow = {--Show Adrenaline rush CD
			order = 139,
			name = "Show Adrenaline Rush bar CD",
			desc = "Display the Adrenaline rush cooldown bar",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ShowARCD = val
			end,
			get = function(info) return SliceCommander_Save.ShowARCD end
		},
		ARMarioMod = {--Enable Mario mod
			order = 140,
			name = "Enable Mario mod",
			desc = "Enable mario start music during Adrenaline rush buff",
			type = "toggle",
			set = function(info,val)
				SliceCommander_Save.ARMarioMod = val
			end,
			get = function(info) return SliceCommander_Save.ARMarioMod end
		},
	}
}

SC_OptionsTable = {
	name = "SliceCommander",
	handler = SliceCommander,
	type = "group",
	args = {--SliceCommander
		IsLocked = {--Lock
			order = 1,
			name = "Lock",
			desc = "Disable Left Click to Move",
			type = "toggle",
			set = function(info,val)
				SliceCommander:LockCkecked(val)
			end,
			get = function(info) return SliceCommander_Save.IsLocked end
		},
		FullTimer = {--Full timer
			order = 2,
			name = "Full Timer",
			desc = "Make timer full bar duration",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.FullTimer = val end,
			get = function(info) return SliceCommander_Save.FullTimer end
		},
		PadLatency = {--Latency
			order = 3,
			name = "Enable Latency",
			desc = "Pad Alerts with Latency",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.PadLatency = val end,
			get = function(info) return SliceCommander_Save.PadLatency end
		},
		SpellText = {--Spell text
			order = 4,
			name = "Spell Text",
			desc = "Enable spell text on bars",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.SpellText = val end,
			get = function(info) return SliceCommander_Save.SpellText end
		},
		SoundCombat = {--Disable sound out of combat
			order = 5,
			name = "Sound Combat",
			desc = "Disable sounds out of combat",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.SoundCombat = val end,
			get = function(info) return SliceCommander_Save.SoundCombat end
		},
		headerDisplaySetting = {--CDisplay Setting
			order = 6,
			name = "Display Setting",
			type = "header"
		},
		BarTexture = {--Texture
			order = 7,
			name = "Bar Texture",
			desc = "Bar Texture for timer and energy",
			type = "select",
			values = function()
				returnArray = {}
				for key, value in pairs(SliceCommander_BarTextures) do 
					returnArray[key] = key
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander_Save.BarTexture = val
				SliceCommander:Config_RetextureBars(SliceCommander:BarTexture())
			end,
			get = function(info) return SliceCommander_Save.BarTexture end
		},
		Width = {--Width
			order = 9,
			name = "Width",
			desc = "Bar Width",
			type = "range",
			min = 125,
			max = 300,
			step = 1,
			bigStep = 5,
			set = function(info,val)
				SliceCommander_Save.Width = val
				SliceCommander:SetWidth(val)
			end,
			get = function(info) return SliceCommander_Save.Width end,
			isPercent = false
		},
		EnergyHeight = {--Energy bar height
			order = 10,
			name = "Energy Height",
			desc = "EnergyBar Height",
			type = "range",
			min = 1,
			max = 40,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander_Save.EnergyHeight = val
				SliceCommander:SetEnergyHeight(val)
			end,
			get = function(info) return SliceCommander_Save.EnergyHeight end,
			isPercent = false
		},
		TimerHeight = {--Timer height
			order = 11,
			name = "Timer Height",
			desc = "TimerBar Height",
			type = "range",
			min = 1,
			max = 50,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander_Save.TimerHeight = val
				SliceCommander:SetTimersHeight(val)
			end,
			get = function(info) return SliceCommander_Save.TimerHeight end,
			isPercent = false
		},
		BarMargin = {--Margin
			order = 12,
			name = "Bar Margin",
			desc = "Bar Margin",
			type = "range",
			min = -2,
			max = 10,
			step = 1,
			bigStep = 1,
			set = function(info,val) SliceCommander_Save.BarMargin = val end,
			get = function(info) return SliceCommander_Save.BarMargin end,
			isPercent = false
		},
		FrameOpacity = {--Opacity
			order = 13,
			name = "Frame opacity",
			desc = "Frame opacity",
			type = "range",
			min = 25,
			max = 100,
			step = 1,
			bigStep = 1,
			set = function(info,val)
				SliceCommander:FrameOpacity(val)
				SliceCommander_Save.FrameOpacity = val
			end,
			get = function(info) return SliceCommander_Save.FrameOpacity end,
			isPercent = false
		},
		headerCheckHealth = {--Check health header
			order = 14,
			name = "Enable 35% backstab warning",
			type = "header"
		},
		checkHealthSpec1 = {--Check health spec1
			order = 15,
			name = "Spec 1",
			desc = "Check health for Spec 1",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.checkHealthSpec1 = val end,
			get = function(info) return SliceCommander_Save.checkHealthSpec1 end
		},
		checkHealthSpec2 = {--Check health spec2
			order = 16,
			name = "Spec 2",
			desc = "Check health for Spec 2",
			type = "toggle",
			set = function(info,val) SliceCommander_Save.checkHealthSpec2 = val end,
			get = function(info) return SliceCommander_Save.checkHealthSpec2 end
		},
		HealthUnder = {--Texture
			order = 17,
			name = "Sound under 35% health",
			desc = "The sound play when the health reach 35% health",
			type = "select",
			values = function()
				returnArray = {}
				for ignore, SoundName in pairs(SliceCommander_SoundMenu['All']) do   
					returnArray[SoundName] = SoundName
				end
				return returnArray
			end,
			set = function(info,val)
				SliceCommander:SoundTest(val)
				SliceCommander_Save.HealthUnder = val
			end,
			get = function(info)
				return SliceCommander_Save.HealthUnder
			end
		},		
	}
}

function SliceCommander:Config_OtherVars()
	SliceCommander_Spark[1]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", (SliceCommander_Save.Energy1 / UnitManaMax("player") * SliceCommander_Save.Width), 0)
	SliceCommander_Spark[2]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", (SliceCommander_Save.Energy2 / UnitManaMax("player") * SliceCommander_Save.Width), 0)
	SliceCommander_Spark[3]:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", (SliceCommander_Save.Energy3 / UnitManaMax("player") * SliceCommander_Save.Width), 0)
end

function SliceCommander:LockCkecked(checked)
	if checked then
		SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
		SliceCommanderFrame:SetAlpha(0)
		SliceCommanderFrame:EnableMouse(false)
		SliceCommander_Save.IsLocked = true
	else
		SliceCommander:SetPoisonTransparency(100)
		SliceCommanderFrame:SetAlpha(.5)
		SliceCommanderFrame:EnableMouse(true)
		SliceCommander_Save.IsLocked = false
	end	
end

function SliceCommander:Config_RetextureBars(texture)
	VTimerEnergy:SetStatusBarTexture(texture)
	SC.BARS['Rup']['obj']:SetStatusBarTexture(texture)
	SC.BARS['Gar']['obj']:SetStatusBarTexture(texture)
	SC.BARS['DP']['obj']:SetStatusBarTexture(texture)
	SC.BARS['ENV']['obj']:SetStatusBarTexture(texture)
	SC.BARS['ToT']['obj']:SetStatusBarTexture(texture)
	SC.BARS['REC']['obj']:SetStatusBarTexture(texture)
	SC.BARS['SnD']['obj']:SetStatusBarTexture(texture)
	SC.BARS['VEN']['obj']:SetStatusBarTexture(texture)
	SC.BARS['VENCD']['obj']:SetStatusBarTexture(texture)
	SC.BARS['MH']['obj']:SetStatusBarTexture(texture)
	SC.BARS['OH']['obj']:SetStatusBarTexture(texture)
	SC.BARS['KS']['obj']:SetStatusBarTexture(texture)
	SC.BARS['CS']['obj']:SetStatusBarTexture(texture)
	SC.BARS['THREAT']['obj']:SetStatusBarTexture(texture)
	SC.BARS['AR']['obj']:SetStatusBarTexture(texture)
	SC.BARS['ARCD']['obj']:SetStatusBarTexture(texture)
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i].bg:SetTexture(texture)
	end
end

function SliceCommander:SetScale(NewScale) 
	SliceCommanderFrame:SetScale(NewScale/100)
	SC.BARS['VEN']['obj']:SetScale(NewScale/100)
	SC.BARS['VENCD']['obj']:SetScale(NewScale/100)
	SC.BARS['Rup']['obj']:SetScale(NewScale/100)
	SC.BARS['Gar']['obj']:SetScale(NewScale/100)
	SC.BARS['CP']['obj']:SetScale(NewScale/100)
	SC.BARS['DP']['obj']:SetScale(NewScale/100)
	SC.BARS['ENV']['obj']:SetScale(NewScale/100)
	SC.BARS['SnD']['obj']:SetScale(NewScale/100)
	SC.BARS['KS']['obj']:SetScale(NewScale/100)
	SC.BARS['CS']['obj']:SetScale(NewScale/100)
	SC.BARS['MH']['obj']:SetScale(NewScale/100)
	SC.BARS['OH']['obj']:SetScale(NewScale/100)
	SC.BARS['ToT']['obj']:SetScale(NewScale/100)
	SC.BARS['REC']['obj']:SetScale(NewScale/100)
	SC.BARS['THREAT']['obj']:SetScale(NewScale/100)
	SC.BARS['AR']['obj']:SetScale(NewScale/100)
	SC.BARS['ARCD']['obj']:SetScale(NewScale/100)
end

function SliceCommander:SetWidth(w) 
	VTimerEnergy:SetWidth(w)
	SC.BARS['MH']['obj']:SetWidth(w)
	SC.BARS['OH']['obj']:SetWidth(w)
	SC.BARS['THREAT']['obj']:SetWidth(w)
	h = SC.BARS['Rup']['obj'].iconBackground:GetHeight()
	SC.BARS['Rup']['obj']:SetWidth(w-h)
	SC.BARS['Gar']['obj']:SetWidth(w-h)
	SC.BARS['DP']['obj']:SetWidth(w-h)
	SC.BARS['ENV']['obj']:SetWidth(w-h)
	SC.BARS['SnD']['obj']:SetWidth(w-h)
	SC.BARS['KS']['obj']:SetWidth(w-h)
	SC.BARS['CS']['obj']:SetWidth(w-h)
	SC.BARS['ToT']['obj']:SetWidth(w-h)
	SC.BARS['REC']['obj']:SetWidth(w-h)
	SC.BARS['VEN']['obj']:SetWidth(w-h)
	SC.BARS['VENCD']['obj']:SetWidth(w-h)
	SC.BARS['AR']['obj']:SetWidth(w-h)
	SC.BARS['ARCD']['obj']:SetWidth(w-h)
	SC.BARS['CP']['obj']:SetWidth(w)
	cx = 0
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:ClearAllPoints()
		SC.BARS['CP']['obj'].combos[i]:SetPoint("TOPLEFT", SC.BARS['CP']['obj'], "TOPLEFT", cx, 0)
		SC.BARS['CP']['obj'].combos[i]:SetPoint("BOTTOMRIGHT", SC.BARS['CP']['obj'], "BOTTOMLEFT", cx + ((w-(2*4))/5) , 0)
		cx = cx + ((w-(2*4))/5) + 2 --width = ((w-(2*4))/5)
	end
	SliceCommander:Config_OtherVars()
end

function SliceCommander:SetEnergyHeight(h)
	SliceCommanderFrame:SetWidth(h)
	SliceCommanderFrame:SetHeight(h)
	VTimerEnergy:SetHeight(h)
	VTimerEnergyTxt:SetHeight(h)
	SliceCommander_Combo:SetHeight(h)
	SliceCommander_Spark[1]:SetHeight(h)
	SliceCommander_Spark[2]:SetHeight(h)
	SliceCommander_Spark[3]:SetHeight(h)
end

function SliceCommander:SetTimerHeight(BAR, h)
	BAR:SetHeight(h)
	BAR.text:SetHeight(h)
	BAR.text2:SetHeight(h)
	BAR.textIcon:SetHeight(h+2)
	BAR.textIcon:SetWidth(h+2)
	BAR.icon:SetHeight(h)
	BAR.icon:SetWidth(h)
	BAR.iconBackground:SetHeight(h+2)
	BAR.iconBackground:SetWidth(h+2)
end

function SliceCommander:SetTimersHeight(h)
	SliceCommander:SetTimerHeight(SC.BARS['VEN']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['VENCD']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['Rup']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['Gar']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['DP']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['ENV']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['SnD']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['KS']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['CS']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['ToT']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['REC']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['THREAT']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['AR']['obj'], h)
	SliceCommander:SetTimerHeight(SC.BARS['ARCD']['obj'], h)
	
	for i = 1, 3 do
		SC.BARS['REC']['tick']['obj'][i]:SetHeight(h)
	end
	for i = 1, 3 do
		SC.BARS['Gar']['tick']['obj'][i]:SetHeight(h)
	end
	for i = 1, 3 do
		SC.BARS['Rup']['tick']['obj'][i]:SetHeight(h)
	end
	SC.BARS['CP']['obj']:SetHeight(h)
	SC.BARS['CP']['obj'].comboText:SetHeight(h)
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:SetHeight(h-2)
	end
	SC.BarFont2:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", h-2)
	SC.BarFont4:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", h-2)
	SliceCommander:SetWidth(SliceCommander_Save.Width)
end

function SliceCommander:FrameOpacity(opValue)
	frameHealth:SetAlpha(opValue/100)
	SliceCommander:SetPoisonTransparency(opValue)
	SC.BARS['BF']['icon']:SetAlpha(opValue/100)
	SC.BARS['CP']['obj']:SetAlpha(opValue/100)
	SC.BARS['VEN']['obj']:SetAlpha(opValue/100)
	SC.BARS['VENCD']['obj']:SetAlpha(opValue/100)
	SC.BARS['Rup']['obj']:SetAlpha(opValue/100)
	SC.BARS['Gar']['obj']:SetAlpha(opValue/100)
	SC.BARS['DP']['obj']:SetAlpha(opValue/100)
	SC.BARS['ENV']['obj']:SetAlpha(opValue/100)
	SC.BARS['SnD']['obj']:SetAlpha(opValue/100)
	SC.BARS['KS']['obj']:SetAlpha(opValue/100)
	SC.BARS['CS']['obj']:SetAlpha(opValue/100)
	SC.BARS['ToT']['obj']:SetAlpha(opValue/100)
	SC.BARS['REC']['obj']:SetAlpha(opValue/100)
	SC.BARS['THREAT']['obj']:SetAlpha(opValue/100)
	SC.BARS['AR']['obj']:SetAlpha(opValue/100)
	SC.BARS['ARCD']['obj']:SetAlpha(opValue/100)
end

function SliceCommander:MoveStart()
	if SliceCommander_Save.IsLocked == false then
		SliceCommanderFrame:StartMoving()
	end
end

function SliceCommander:MoveStop()
	if SliceCommander_Save.IsLocked == false then
		SliceCommanderFrame:StopMovingOrSizing()
	end		
end

function SliceCommander:BarTexture() 
	if SliceCommander_Save.BarTexture then
		return SliceCommander_BarTextures[SliceCommander_Save.BarTexture]
	else
		return "Interface\\AddOns\\SliceCommander\\Images\\Smooth.tga"
	end
	
end

function SliceCommander:SoundTest(name) 
	if SliceCommander_Sounds[name] and SliceCommander_Sounds[name] ~= "" and SliceCommander_Sounds[name] ~= nil then
		PlaySoundFile( SliceCommander_Sounds[name], "Master")
	end
end

function SliceCommander:Sound(saved) 
	if isCombat()==1 then
		if SliceCommander_Save[saved] then
			if SliceCommander_Sounds[SliceCommander_Save[saved]] ~= "" and SliceCommander_Sounds[SliceCommander_Save[saved]] ~= nil then
				PlaySoundFile( SliceCommander_Sounds[SliceCommander_Save[saved]], "Master" )
			end
		end
	end
end

function SliceCommander:ChangeAnchor()
	offSetSize = SliceCommander_Save.BarMargin -- other good values, -1, -2
	LastAnchorNeg = VTimerEnergy
	AnchorFromNeg = "BOTTOMRIGHT"
	AnchorToNeg = "TOPRIGHT"
	LastAnchorPos = VTimerEnergy
	AnchorFromPos = "TOPRIGHT"
	AnchorToPos = "BOTTOMRIGHT"
	for i = 1, 10 do
		--under
		if SliceCommander_Save.PosKS == i and SC.BARS['KS']['expire'] ~= 0 then
			SC.BARS['KS']['obj']:ClearAllPoints()
			SC.BARS['KS']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['KS']['obj']
		end
		if SliceCommander_Save.PosCS == i and SC.BARS['CS']['expire'] ~= 0 then
			SC.BARS['CS']['obj']:ClearAllPoints()
			SC.BARS['CS']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['CS']['obj']
		end
		if SliceCommander_Save.PosCP == i and SC.BARS['CP']['expire'] ~= 0 then
			SC.BARS['CP']['obj']:ClearAllPoints()
			SC.BARS['CP']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['CP']['obj']
		end
		if SliceCommander_Save.PosREC == i and SC.BARS['REC']['expire'] ~= 0 then
			SC.BARS['REC']['obj']:ClearAllPoints()
			SC.BARS['REC']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['REC']['obj']
		end
		if SliceCommander_Save.PosSND == i and SC.BARS['SnD']['expire'] ~= 0 then
			SC.BARS['SnD']['obj']:ClearAllPoints()
			SC.BARS['SnD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['SnD']['obj']
		end
		if SliceCommander_Save.PosRUP == i and SC.BARS['Rup']['expire'] ~= 0 then
			SC.BARS['Rup']['obj']:ClearAllPoints()
			SC.BARS['Rup']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['Rup']['obj']
		end
		if SliceCommander_Save.PosGAR == i and SC.BARS['Gar']['expire'] ~= 0 then
			SC.BARS['Gar']['obj']:ClearAllPoints()
			SC.BARS['Gar']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['Gar']['obj']
		end
		if SliceCommander_Save.PosTOT == i and SC.BARS['ToT']['expire'] ~= 0 then
			SC.BARS['ToT']['obj']:ClearAllPoints()
			SC.BARS['ToT']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ToT']['obj']
		end
		if SliceCommander_Save.PosVEN == i and SC.BARS['VEN']['expire'] ~= 0 then
			SC.BARS['VEN']['obj']:ClearAllPoints()
			SC.BARS['VEN']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['VEN']['obj']
		end
		if SliceCommander_Save.PosVEN == i and SC.BARS['VENCD']['expire'] ~= 0 then
			SC.BARS['VENCD']['obj']:ClearAllPoints()
			SC.BARS['VENCD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['VENCD']['obj']
		end
		if SliceCommander_Save.PosDP == i and SC.BARS['DP']['expire'] ~= 0 then
			SC.BARS['DP']['obj']:ClearAllPoints()
			SC.BARS['DP']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['DP']['obj']
		end
		if SliceCommander_Save.PosENV == i and SC.BARS['ENV']['expire'] ~= 0 then
			SC.BARS['ENV']['obj']:ClearAllPoints()
			SC.BARS['ENV']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ENV']['obj']
		end
		if SliceCommander_Save.PosThreat == i and SC.BARS['THREAT']['expire'] ~= 0 then
			SC.BARS['THREAT']['obj']:ClearAllPoints()
			SC.BARS['THREAT']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['THREAT']['obj']
		end
		if SliceCommander_Save.PosAR == i and SC.BARS['AR']['expire'] ~= 0 then
			SC.BARS['AR']['obj']:ClearAllPoints()
			SC.BARS['AR']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['AR']['obj']
		end
		if SliceCommander_Save.PosAR == i and SC.BARS['ARCD']['expire'] ~= 0 then
			SC.BARS['ARCD']['obj']:ClearAllPoints()
			SC.BARS['ARCD']['obj']:SetPoint(AnchorFromPos, LastAnchorPos, AnchorToPos, 0, offSetSize*-1)
			LastAnchorPos = SC.BARS['ARCD']['obj']
		end
		
		--on top
		if SliceCommander_Save.PosKS == i*-1 and SC.BARS['KS']['expire'] ~= 0 then
			SC.BARS['KS']['obj']:ClearAllPoints()
			SC.BARS['KS']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['KS']['obj']
		end
		if SliceCommander_Save.PosCS == i*-1 and SC.BARS['CS']['expire'] ~= 0 then
			SC.BARS['CS']['obj']:ClearAllPoints()
			SC.BARS['CS']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['CS']['obj']
		end
		if SliceCommander_Save.PosCP == i*-1 and SC.BARS['CP']['expire'] ~= 0 then
			SC.BARS['CP']['obj']:ClearAllPoints()
			SC.BARS['CP']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['CP']['obj']
		end
		if SliceCommander_Save.PosREC == i*-1 and SC.BARS['REC']['expire'] ~= 0 then
			SC.BARS['REC']['obj']:ClearAllPoints()
			SC.BARS['REC']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['REC']['obj']
		end
		if SliceCommander_Save.PosSND == i*-1 and SC.BARS['SnD']['expire'] ~= 0 then
			SC.BARS['SnD']['obj']:ClearAllPoints()
			SC.BARS['SnD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['SnD']['obj']
		end
		if SliceCommander_Save.PosRUP == i*-1 and SC.BARS['Rup']['expire'] ~= 0 then
			SC.BARS['Rup']['obj']:ClearAllPoints()
			SC.BARS['Rup']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['Rup']['obj']
		end
		if SliceCommander_Save.PosGAR == i*-1 and SC.BARS['Gar']['expire'] ~= 0 then
			SC.BARS['Gar']['obj']:ClearAllPoints()
			SC.BARS['Gar']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['Gar']['obj']
		end
		if SliceCommander_Save.PosTOT == i*-1 and SC.BARS['ToT']['expire'] ~= 0 then
			SC.BARS['ToT']['obj']:ClearAllPoints()
			SC.BARS['ToT']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ToT']['obj']
		end
		if SliceCommander_Save.PosVEN == i*-1 and SC.BARS['VEN']['expire'] ~= 0 then
			SC.BARS['VEN']['obj']:ClearAllPoints()
			SC.BARS['VEN']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['VEN']['obj']
		end
		if SliceCommander_Save.PosVEN == i*-1 and SC.BARS['VENCD']['expire'] ~= 0 then
			SC.BARS['VENCD']['obj']:ClearAllPoints()
			SC.BARS['VENCD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['VENCD']['obj']
		end
		if SliceCommander_Save.PosDP == i*-1 and SC.BARS['DP']['expire'] ~= 0 then
			SC.BARS['DP']['obj']:ClearAllPoints()
			SC.BARS['DP']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['DP']['obj']
		end
		if SliceCommander_Save.PosENV == i*-1 and SC.BARS['ENV']['expire'] ~= 0 then
			SC.BARS['ENV']['obj']:ClearAllPoints()
			SC.BARS['ENV']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ENV']['obj']
		end
		if SliceCommander_Save.PosThreat == i*-1 and SC.BARS['THREAT']['expire'] ~= 0 then
			SC.BARS['THREAT']['obj']:ClearAllPoints()
			SC.BARS['THREAT']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['THREAT']['obj']
		end
		if SliceCommander_Save.PosAR == i*-1 and SC.BARS['AR']['expire'] ~= 0 then
			SC.BARS['AR']['obj']:ClearAllPoints()
			SC.BARS['AR']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['AR']['obj']
		end
		if SliceCommander_Save.PosAR == i*-1 and SC.BARS['ARCD']['expire'] ~= 0 then
			SC.BARS['ARCD']['obj']:ClearAllPoints()
			SC.BARS['ARCD']['obj']:SetPoint(AnchorFromNeg, LastAnchorNeg, AnchorToNeg, 0, offSetSize)
			LastAnchorNeg = SC.BARS['ARCD']['obj']
		end
	end
end

function isCombat()
	if SliceCommander_Save.SoundCombat==true then
		if UnitAffectingCombat("player")==1 then
			return 1
		else
			return 0
		end
	else
		return 1
	end
end

function SliceCommander:UNIT_COMBO_POINTS(eventName, unit)
	if unit == "player" then
		SC.BARS['CP']['target'] = UnitGUID("target")
		SliceCommander:TestDPCP()
		SliceCommander:SetComboPts()
		SliceCommander:ChangeAnchor()
	end
end

function SliceCommander:PLAYER_TARGET_CHANGED(eventName, arg1)
	for i = 1,3 do
		SC.BARS['Rup']['tick']['expire'][i] = 0
	end
	frameHealth:Hide()
	SliceCommander:SetComboPts()
end

function SliceCommander:SetComboPts()
	points = GetComboPoints("player")
	if points == 0 then
		if UnitGUID("target") ~= SC.BARS['CP']['target'] then
			return
		end
	end
	
	SliceCommander_Combo:SetText("")
	SC.BARS['CP']['obj'].comboText:SetText("")
	for i = 1, 5 do
		SC.BARS['CP']['obj'].combos[i]:Hide()
	end
	SC.BARS['CP']['obj']:Hide()
	SC.BARS['CP']['expire'] = 0
	
	if points ~= 0 then
		SliceCommander_Combo:SetText(points)
		if SliceCommander_Save.CPBarShow == true then
			SC.BARS['CP']['expire'] = points
			SC.BARS['CP']['obj'].comboText:SetText(points)
			for i = 1, points do
				SC.BARS['CP']['obj'].combos[i]:Show()
			end
			SC.BARS['CP']['obj']:Show()
			if points < 3 then
				SC.BarFont4:SetShadowColor(0,0,0, 1)
				SC.BarFont4:SetTextColor(213/255,200/255,184/255,1)
			else
				SC.BarFont4:SetShadowColor(0,0,0, 0)
				SC.BarFont4:SetTextColor(0,0,0, 1)
			end
		end
	end
end

function SliceCommander:OnDisable()
	SliceCommander:UnregisterAllEvents()
end

function SliceCommander:NewFrame(r, g, b)
	f = CreateFrame("StatusBar", nil, UIParent)
	
	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetValue(0)
	
	f:SetBackdrop({
		  bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		  edgeFile="",
		  tile=true, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=-1}
		})
	f:SetBackdropBorderColor(1,1,1,1)
	f:SetBackdropColor(.1,.1,.1)
	
	-- text on the right --			
	f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	f.text:SetFontObject(SC.BarFont2)
	f.text:SetWidth(40)
	f.text:SetPoint("TOPRIGHT", f, "TOPRIGHT",  -5, 0)
	f.text:SetJustifyH("RIGHT")
	
	f.iconBackground = f:CreateTexture(nil, "BACKGROUND")
	f.icon = f:CreateTexture(nil, "OVERLAY")
	f.icon:SetPoint("BOTTOMLEFT", f.iconBackground, "BOTTOMLEFT", 1, 1)
	f.iconBackground:SetPoint("TOPRIGHT", f, "TOPLEFT", 0, 1)
	f.icon:SetTexCoord(.08, .92, .08, .92)
	f.iconBackground:SetTexture(.1,.1,.1, 1)
	
	-- Count on the icon --
	f.textIcon = f:CreateFontString(nil, "OVERLAY", nil)
	f.textIcon:SetFontObject(SC.BarFont2)
	f.textIcon:SetPoint("CENTER", f.icon , "CENTER", f.icon:GetHeight()+4, 0)
	f.textIcon:SetJustifyH("CENTER")
	
	-- text on the left --
	f.text2 = f:CreateFontString(nil, nil, nil)
	f.text2:SetPoint("TOPLEFT", f, "TOPLEFT", 2, 0)
	f.text2:SetFontObject(SC.BarFont2)
	f.text2:SetWidth(120)
	f.text2:SetPoint("RIGHT", f, "RIGHT", 0, 0)
	f.text2:SetJustifyH("CENTER")
	
	f:SetStatusBarColor(r, g, b)
	
	return f
	
end

function SliceCommander:CPFrame()
	f = CreateFrame("StatusBar", nil, UIParent)
	
	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", 0, 0)
	f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 0)
	f:SetBackdrop({
		  bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		  edgeFile="",
		  tile=false, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=-1}
		})
	f:SetBackdropBorderColor(1,1,1,1)
	f:SetBackdropColor(.1,.1,.1)
	
	f.combos = {}
	
	for i = 1, 5 do
		combo = CreateFrame("Frame", nil, f)
		combo.bg = combo:CreateTexture(nil, "BACKGROUND")
		combo.bg:SetAllPoints(combo)
		combo.bg:SetTexture("Interface\\AddOns\\SliceCommander\\Images\\solid.tga")
		combo:Hide()
		f.combos[i] = combo
	end

	f.overlay = CreateFrame("Frame", nil, f)
	f.overlay:SetAllPoints(f)
	
	f.comboText = f.overlay:CreateFontString(nil, "OVERLAY")
	f.comboText:SetFontObject(SC.BarFont4)
	f.comboText:SetWidth(120)
	f.comboText:SetJustifyH("CENTER")
	f.comboText:SetAllPoints(f.overlay)
	
	f:Hide()
	return f
	
end

function SliceCommander:NewPoisonFrame()
	f = CreateFrame("StatusBar", nil, UIParent)
	
	f:SetHeight(2)
	f:SetFrameLevel(2)
	f:SetStatusBarTexture(SliceCommander:BarTexture())
	f:SetStatusBarColor(64/255, 167/255, 64/255)
	f:SetMinMaxValues(0, 3600*1000)
	f:SetFrameStrata("MEDIUM")
	f:Hide()
	
	f:SetBackdrop({
		bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
		edgeFile="",
		tile=true, tileSize=1, edgeSize=0,
		insets={left=0, right=0, top=0, bottom=0}
	})
	f:SetBackdropBorderColor(1,1,1)
	f:SetBackdropColor(.1,.1,.1,0)
	return f
end

function SliceCommander:CreateCore()
	SliceCommanderFrame = CreateFrame('Frame', 'SliceCommanderFrame', UIParent)
	SliceCommanderFrame:SetToplevel(true)
	SliceCommanderFrame:EnableMouse(false)
	SliceCommanderFrame:SetMovable(true)
	SliceCommanderFrame:SetWidth(28)
	SliceCommanderFrame:SetHeight(28)
	SliceCommanderFrame:SetPoint('TOP', UIParent, 'TOP', 0, -300)
	SliceCommanderFrame:SetBackdrop({
	  bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
	  edgeFile="",
	  tile=true, tileSize=1, edgeSize=0,
	  insets={left=-1, right=-1, top=-1, bottom=-1}
	})
	SliceCommanderFrame:SetBackdropColor(0.7,0.2,0.2,1)
	SliceCommanderFrame:SetScript("OnMouseDown",function () SliceCommander:MoveStart() end)
	SliceCommanderFrame:SetScript("OnMouseUp",function () SliceCommander:MoveStop() end)
	SliceCommanderFrame:SetScript("OnUpdate",function () SliceCommander:OnUpdate() end)
	
	VTimerEnergy = CreateFrame('StatusBar', 'VTimerEnergy', UIParent)
	VTimerEnergy:SetSize(200,20)
	VTimerEnergy:SetMinMaxValues(0,100)
	VTimerEnergy:SetPoint('TOPLEFT', SliceCommanderFrame, 'TOPRIGHT', 0, 0)
	VTimerEnergy:SetFrameLevel(1)
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"))
	VTimerEnergy:SetBackdrop({
	  bgFile="Interface\\AddOns\\SliceCommander\\Images\\solid.tga",
	  edgeFile="",
	  tile=true, tileSize=1, edgeSize=0,
	  insets={left=-1, right=-1, top=-1, bottom=-1}
	})
	VTimerEnergy:SetBackdropBorderColor(1,1,1,1)
	VTimerEnergy:SetBackdropColor(.1,.1,.1)
	VTimerEnergy:SetStatusBarTexture(SliceCommander:BarTexture())
	VTimerEnergy:SetFrameStrata("MEDIUM")
	VTimerEnergy:SetStatusBarColor(234/255, 234/255, 234/255)
	if SliceCommander_Save.HideEnergy then
		VTimerEnergy:Hide()
	else
		VTimerEnergy:Show()
	end
	
	VTimerEnergyTxt = VTimerEnergy:CreateFontString('VTimerEnergyTxt', 'OVERLAY', GameFontWhite)
	VTimerEnergyTxt:SetJustifyH("RIGHT")
	VTimerEnergyTxt:SetSize(49,20)
	VTimerEnergyTxt:SetPoint('RIGHT', VTimerEnergy, 'RIGHT', -5, 0)
	VTimerEnergyTxt:SetFontObject(SC.BarFont)
	
	SliceCommander_Combo = VTimerEnergy:CreateFontString('SliceCommander_Combo', 'OVERLAY', GameFontWhite)
	SliceCommander_Combo:SetJustifyH("LEFT")
	SliceCommander_Combo:SetSize(20,20)
	SliceCommander_Combo:SetPoint('LEFT', VTimerEnergy, 'LEFT', 5, 0)
	SliceCommander_Combo:SetFontObject(SC.BarFont3)
	
	SliceCommander_Spark = {}
	for i = 1, 3 do
		SliceCommander_Spark[i] = VTimerEnergy:CreateTexture(nil, 'OVERLAY', GameFontWhite)
		SliceCommander_Spark[i]:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		SliceCommander_Spark[i]:SetBlendMode('ADD')
		SliceCommander_Spark[i]:SetSize(5,20)
	end
end

function SliceCommander:NewTickArray(BAR)
	for i = 1, 3 do
		BAR['tick']['obj'][i] = BAR['obj']:CreateTexture('SliceCommander_Spark3', 'OVERLAY', GameFontWhite)
		BAR['tick']['obj'][i]:SetTexture('Interface\\AddOns\\SliceCommander\\Images\\solid.tga')
		BAR['tick']['obj'][i]:SetWidth(1)
		BAR['tick']['obj'][i]:SetVertexColor(226/255, 226/255, 226/255, 0.75)
	end
end

function SliceCommander:OnInitialize()
	localizedClass, englishClass = UnitClass("player")
	if englishClass == "ROGUE" then
		
		if SliceCommander:TestValueOptions() then
			SliceCommander:SetDefaultOptions()
		end
		
		AceConfig:RegisterOptionsTable("SliceCommander", SC_OptionsTable)
		AceConfig:RegisterOptionsTable("SliceCommander_DisplayTimer", SC_OptionsTable_DisplayTimer)
		AceConfig:RegisterOptionsTable("SliceCommander_Sound", SC_OptionsTable_Sound)
		
		SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander","SliceCommander")
		SetDefaultOpttion.default = function() SliceCommander:SetDefaultOptions() end
		
		SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander_DisplayTimer",SC_DISPLAY_SETTINGS,"SliceCommander")
		SetDefaultOpttion.default = function() SliceCommander:SetDefaultOptions() end
		
		SetDefaultOpttion = AceConfigDialog:AddToBlizOptions("SliceCommander_Sound",SC_LANG_SOUND,"SliceCommander")
		SetDefaultOpttion.default = function() SliceCommander:SetDefaultOptions() end
		
		SliceCommander:RegisterEvent("UNIT_COMBO_POINTS")
		SliceCommander:RegisterEvent("PLAYER_TARGET_CHANGED")
		SliceCommander:RegisterEvent("UNIT_HEALTH")
		SliceCommander:RegisterEvent("PLAYER_LOGIN")
		
		SC.soundStatus = GetCVar('Sound_EnableSFX')
		
		SC.BarFont = CreateFont("VTimerFont")
		SC.BarFont:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", 17)
		SC.BarFont:SetShadowColor(0,0,0, 0.7)
		SC.BarFont:SetTextColor(1,1,1,1)
		SC.BarFont:SetShadowOffset(0.8, -0.8)
		
		SC.BarFont2 = CreateFont("VTimerFont2")
		SC.BarFont2:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", 8)
		SC.BarFont2:SetShadowColor(0,0,0, 0.7)
		SC.BarFont2:SetTextColor(213/255,200/255,184/255,1)
		SC.BarFont2:SetShadowOffset(0.8, -0.8)
		
		SC.BarFont3 = CreateFont("VTimerFont1O")
		SC.BarFont3:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", 17)
		SC.BarFont3:SetShadowColor(0,0,0, 0.2)
		SC.BarFont3:SetTextColor(0,0,0,1)
		SC.BarFont3:SetShadowOffset(0.8, -0.8)
		
		SC.BarFont4 = CreateFont("VTimerFont4")
		SC.BarFont4:SetFont("Interface\\AddOns\\SliceCommander\\Fonts\\FRIZQT__.TTF", 8)
		SC.BarFont4:SetShadowColor(0,0,0, 1)
		SC.BarFont4:SetTextColor(213/255,200/255,184/255,1)
		SC.BarFont4:SetShadowOffset(0.8, -0.8)
		
		SliceCommander:CreateCore()
		
		SC.LastEnergy = UnitMana('player')
		SC.curCombo = 0
		
		SC.BARS['CP']['obj'] = SliceCommander:CPFrame()
		
		SC.BARS['KS']['obj'] = SliceCommander:NewFrame(227/255, 186/255, 132/255)
		
		SC.BARS['CS']['obj'] = SliceCommander:NewFrame(227/255, 186/255, 132/255)

		SC.BARS['SnD']['obj'] = SliceCommander:NewFrame(193/255, 79/255, 44/255)
		
		SC.BARS['Rup']['obj'] = SliceCommander:NewFrame(180/255, 38/255, 38/255)
		SliceCommander:NewTickArray(SC.BARS['Rup'])
		
		SC.BARS['Gar']['obj'] = SliceCommander:NewFrame(180/255, 38/255, 38/255)
		SliceCommander:NewTickArray(SC.BARS['Gar'])
		
		SC.BARS['REC']['obj'] = SliceCommander:NewFrame(110/255, 172/255, 163/255)
		SliceCommander:NewTickArray(SC.BARS['REC'])

		SC.BARS['VEN']['obj'] = SliceCommander:NewFrame(110/255, 34/255, 45/255)
		SC.BARS['VEN']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Deadliness")
		SC.BARS['VENCD']['obj'] = SliceCommander:NewFrame(139/255, 78/255, 87/255)
		SC.BARS['VENCD']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Deadliness")

		SC.BARS['AR']['obj'] = SliceCommander:NewFrame(226/255, 130/255, 90/255)
		SC.BARS['AR']['obj'].icon:SetTexture("Interface\\Icons\\Spell_Shadow_ShadowWordDominate")
		SC.BARS['ARCD']['obj'] = SliceCommander:NewFrame(255/255, 173/255, 132/255)
		SC.BARS['ARCD']['obj'].icon:SetTexture("Interface\\Icons\\Spell_Shadow_ShadowWordDominate")
		
		SC.BARS['BF']['icon'] = CreateFrame("Frame",nil,UIParent)
		SC.BARS['BF']['icon']:SetPoint("RIGHT", VTimerEnergy, "RIGHT", -50, 0)
		SC.BARS['BF']['icon']:SetFrameStrata("HIGH")
		SC.BARS['BF']['icon']:SetWidth(20) 
		SC.BARS['BF']['icon']:SetHeight(20)
		
		SliceCommander:TestBF()
		
		frameBF = SC.BARS['BF']['icon']:CreateTexture(nil, "OVERLAY")
		frameBF:SetHeight(20)
		frameBF:SetWidth(20)
		frameBF:SetPoint("RIGHT", SC.BARS['BF']['icon'], "RIGHT", 0, 0)
		frameBF:SetAlpha(1)
		frameBF:SetTexCoord(.08, .92, .08, .92)
		frameBF:SetTexture("Interface\\Icons\\Ability_Warrior_PunishingBlow")
		
		SC.BARS['DP']['obj'] = SliceCommander:NewFrame(64/255, 167/255, 64/255)
		
		SC.BARS['ENV']['obj'] = SliceCommander:NewFrame(64/255, 167/255, 64/255)
		
		SC.BARS['ToT']['obj'] = SliceCommander:NewFrame(77/255, 77/255, 255/255)
		SC.BARS['ToT']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_TricksOftheTrade")
		
		SC.BARS['THREAT']['obj'] = SliceCommander:NewFrame()
		SC.BARS['THREAT']['obj'].iconBackground:SetAlpha(0)
		SC.BARS['THREAT']['obj']:SetMinMaxValues(0, 110)
		
		SC.BARS['MH']['obj'] = SliceCommander:NewPoisonFrame()
		SC.BARS['MH']['obj']:SetPoint("BOTTOMLEFT", VTimerEnergy, "TOPLEFT", 0, -3)
		
		SC.BARS['OH']['obj'] = SliceCommander:NewPoisonFrame()
		SC.BARS['OH']['obj']:SetPoint("TOPLEFT", VTimerEnergy, "BOTTOMLEFT", 0 , 3)
		
		frameHealth = CreateFrame("Frame",nil,UIParent)
		frameHealth:SetPoint("RIGHT", VTimerEnergy, "RIGHT", -50, 0)
		frameHealth:SetFrameStrata("HIGH")
		frameHealth:SetWidth(20)
		frameHealth:SetHeight(20)
		frameHealth:Hide()

		frameHealth.iconHealth = frameHealth:CreateTexture(nil, "OVERLAY")
		frameHealth.iconHealth:SetHeight(20)
		frameHealth.iconHealth:SetWidth(20)
		frameHealth.iconHealth:SetPoint("RIGHT", frameHealth, "RIGHT", 0, 0)
		frameHealth.iconHealth:SetAlpha(1)
		frameHealth.iconHealth:SetTexCoord(.08, .92, .08, .92)
		frameHealth.iconHealth:SetTexture("Interface\\Icons\\Ability_BackStab")
		
		soundRup = {'RUP_Alert', 'RUP_Alert', 'RUP_Alert'}
		soundSnd = {'Tick1', 'Tick2', 'Tick3'}
		RUP_AlertPending = 3
		SND_AlertPending = 3
		DEFAULT_CHAT_FRAME:AddMessage('|cffc14f2cSlice|r|cff40a740Commander|r v'..SC.VERSION)
	else
		SliceCommander:OnDisable()
		return 0
	end
end

function SliceCommander:PLAYER_LOGIN()
	SliceCommander:ApplyConf()
	collectgarbage()
end

function SliceCommander:AbilityCDBar(BAR, display)
	if display ~= true then
		if BAR['obj']:IsVisible() then
			SliceCommander:HideBar(BAR)
		end
		return
	end
	
	start, duration, enabled = GetSpellCooldown(BAR['name'])
	if start == nil or duration == nil or enabled == nil then--not in this spec
		if BAR['obj']:IsVisible()then--if you respect when a cd is enabled
			BAR['expire'] = 0
			SliceCommander:HideBar(BAR)
		end
		return
	end
	if start ~= 0 and duration > 2 and not BAR['obj']:IsVisible() and enabled == 1 then
		SliceCommander:EnableBar(BAR, duration, BAR['name'].." (CD)", (start+duration))
		return
	end
	if start == 0 and BAR['obj']:IsVisible()then
		BAR['expire'] = 0
		SliceCommander:HideBar(BAR)
		return
	end
	if start == 0 or duration < 2 or enabled ~= 1 then
		return
	end
	BAR['expire'] = (start+duration)
	if BAR['expire'] > 0 and SC.tNow < BAR['expire'] then
		x = BAR['expire'] - SC.tNow
	else
		x = 0
	end
	BAR['obj']:SetValue(x)
	BAR['obj'].text:SetText(string.format("%0.1f", x))
end

function SliceCommander:EnableBar(BAR, duration, text, expire)
	BAR['expire'] = expire
	if SliceCommander_Save.FullTimer == true then
		BAR['obj']:SetMinMaxValues(0, duration)
	else
		BAR['obj']:SetMinMaxValues(0, 6.0)
	end
	if SliceCommander_Save.SpellText == true then
		BAR['obj'].text2:SetText(string.format("%s", text))
	else
		BAR['obj'].text2:SetText("")
	end
	BAR['obj']:Show()
	SliceCommander:ChangeAnchor()
end

function SliceCommander:HideBar(BAR)
	BAR['obj'].text:SetText("")
	BAR['expire'] = 0
	SliceCommander:ChangeAnchor()
	BAR['obj']:Hide()
end

function SliceCommander:UpdateBar(BAR, display, soundTable, AlertPending, tick, soundTest)
	if display ~= true then
		SliceCommander:HideBar(BAR)
		return
	end

	last = BAR['expire']
	if BAR['type'] == 1 then
		_, rank, icon, _, _, duration, BAR['expire'], unitCaster = UnitAura("player", BAR['name'], nil, "PLAYER")
	else
		_, rank, icon, _, _, duration, BAR['expire'], unitCaster = UnitDebuff("target", BAR['name'], nil, "PLAYER")
	end
	
	if unitCaster ~= "player" and unitCaster ~= nil then
		BAR['expire'] = last
	end
	
	if BAR['expire'] == nil then
		BAR['expire'] = 0
	end
	if SC.tNow == nil then
		SC.tNow = GetTime()
	end
	if BAR['expire'] > 0 and SC.tNow < BAR['expire'] then
		x = BAR['expire'] - SC.tNow
	else
		x = 0
	end
	if x > 0 then
		if BAR['obj']:IsVisible() ~= 1 then
			BAR['obj'].icon:SetTexture(icon)
			SliceCommander:EnableBar(BAR, duration, BAR['name'], BAR['expire'])
		end
		BAR['obj']:SetValue(x)
		BAR['obj'].text:SetText(string.format("%0.1f", x))
		if tick ~= false then
			_, maxValue = BAR['obj']:GetMinMaxValues()
			widthSeconde = (BAR['obj']:GetWidth())/maxValue
			possible = 0
			value = (x % tick)
			if value == 0 then
				value = tick
			end
			for i = 1,3 do
				if value > x or value > maxValue then
					BAR['tick']['obj'][i]:Hide()
				else
					BAR['tick']['obj'][i]:Show()
					BAR['tick']['obj'][i]:SetPoint("LEFT", BAR['obj'], "LEFT", widthSeconde*value, 0)
					value = value+tick
				end
			end
		end
		
		if soundTest == 1 and BAR['expire'] > last then
			if last == 0 and BAR['expire'] > 0 then
				SliceCommander:Sound("Applied")
			else
				timeLeftOnLast = last - GetTime()
				if timeLeftOnLast <= 1 then
					SliceCommander:Sound("Apply1")
				else
					if timeLeftOnLast <= 2 then
						SliceCommander:Sound("Apply2")
					else
						SliceCommander:Sound("Apply3")
					end
				end
			end
		elseif soundTest == 2 and BAR['expire'] > last then
			if last == 0 and BAR['expire'] > 0 then
				SliceCommander:Sound("RUP_Applied")
			else
				timeLeftOnLast = last - GetTime()
				if timeLeftOnLast <= 1 then
					SliceCommander:Sound("RUP_Refresh1")
				else
					if timeLeftOnLast <= 2 then
						SliceCommander:Sound("RUP_Refresh2")
					else
						SliceCommander:Sound("RUP_Refresh3")
					end
				end
			end
		elseif soundTest == 3 and BAR['expire'] > last then
			if SliceCommander_Save.ARMarioMod then
				if duration > 16 then
					SliceCommander:Sound('ARSound_Glyphed')
				else
					SliceCommander:Sound('ARSound')
				end
			end
			BAR['cd'] = true
			BAR['obj']:SetStatusBarColor(226/255, 130/255, 90/255)
		end
	else
		if BAR['obj']:IsVisible() then
			if soundTest == 1 then
				if UnitAffectingCombat("player") then
					SliceCommander:Sound("Fail")
				else
					SliceCommander:Sound("Expire")
				end
			elseif soundTest == 2 then
				if UnitAffectingCombat("player") then
					SliceCommander:Sound("RUP_Fail")
				else
					SliceCommander:Sound("RUP_Expire")
				end
			end
		
			if tick ~= false then
				for i = 1,3 do
					BAR['tick']['expire'][i] = 0
				end
			end
			SliceCommander:HideBar(BAR)
		end
	end
	if AlertPending ~= nil then
		if x > 0 then
			if x <= 3 then
				if AlertPending == 3 then
					SliceCommander:Sound(soundTable[3])
					AlertPending = 2
				else 
					if x <= 2 then
						if AlertPending == 2 then
							SliceCommander:Sound(soundTable[2])
							AlertPending = 1
						else 
							if x <= 1 then
								if AlertPending == 1 then
									SliceCommander:Sound(soundTable[1])
									AlertPending = 0
								end
							end
						end
					end
				end
			else
				AlertPending = 3
			end
		end
		return AlertPending
	end
end

function SliceCommander:CPColor(name, count, isMine)
	nameUID = UnitGUID("target")
	if not nameUID then
		nameUID = UnitGUID("player")
	end
	for i = 1, 5 do
		if SC.BARS['CP']['target'] == nameUID then
			if name and isMine == "player" and i <= count then
				SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(64/255, 167/255, 64/255)--Green
			else
				SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(192/255, 176/255, 71/255)--Yellow
			end
		else
			SC.BARS['CP']['obj'].combos[i].bg:SetVertexColor(124/255, 124/255, 124/255)--Gray
		end
	end
end

function SliceCommander:PoisonBar()
	if SliceCommander_Save.PoisonShow == true then
		_ , mainHandExpiration , _ , _ , offHandExpiration = GetWeaponEnchantInfo()
		if mainHandExpiration ~= nil then
			SC.BARS['MH']['obj']:SetValue(mainHandExpiration)
			SC.BARS['MH']['obj']:Show()
		else
			SC.BARS['MH']['obj']:Hide()
		end
		if offHandExpiration ~= nil then
			SC.BARS['OH']['obj']:SetValue(offHandExpiration)
			SC.BARS['OH']['obj']:Show()
		else
			SC.BARS['OH']['obj']:Hide()
		end
	else
		SC.BARS['MH']['obj']:Hide()
		SC.BARS['OH']['obj']:Hide()
	end
end

function SliceCommander:UNIT_HEALTH()
	if (GetActiveTalentGroup(false,false) == 1 and SliceCommander_Save.checkHealthSpec1)
		or (GetActiveTalentGroup(false,false) == 2 and SliceCommander_Save.checkHealthSpec2) then
		HP = UnitHealth("target")
		maxHP = UnitHealthMax("target")
		if HP ~= 0 and maxHP ~= 0 and not UnitIsFriend("player","target")then
			pourcentHP = (HP / maxHP) * 100
			if pourcentHP <= 35 then
				if not frameHealth:IsVisible() then
					SliceCommander:Sound("HealthUnder")
					frameHealth:Show()
				end
			else
				if frameHealth:IsVisible() then
					frameHealth:Hide()
				end
			end
		else
			if frameHealth:IsVisible() then
				frameHealth:Hide()
			end
		end
	end
end

function SliceCommander:TargetThreat()
	if SliceCommander_Save.THREATBarShow == false or (SliceCommander_Save.ThreatGroupOnly and GetNumRaidMembers() == 0 and GetNumPartyMembers() == 0) then
		SC.BARS['THREAT']['expire'] = 0
	else
		isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target")
		if rawthreatpct == nil then
			SC.BARS['THREAT']['expire'] = 0
		else
			hexCol = rawthreatpct *(255/110)
			rCol = hexCol-45
			gCol = 255-hexCol+50
			if isTanking == 1 then
				rCol = 210
				gCol = 50
				rawthreatpct = 100
			end
			if rCol > 210 then
				rCol = 210
			end
			if rCol < 50 then
				rCol = 50
			end	
			if gCol > 210 then
				gCol = 210
			end
			if gCol < 50 then
				gCol = 50
			end			
			bCol = 50
			SC.BARS['THREAT']['expire'] = rawthreatpct
		end
	end
	if SC.BARS['THREAT']['expire'] == 0 then
		SC.BARS['THREAT']['obj']:Hide()
	else
		SC.BARS['THREAT']['obj']:SetValue(SC.BARS['THREAT']['expire'])
		SC.BARS['THREAT']['obj'].text:SetText(string.format("%0.1f", SC.BARS['THREAT']['expire']))
		SC.BARS['THREAT']['obj']:SetStatusBarColor(rCol/255,gCol/255,bCol/255)
		SC.BARS['THREAT']['obj']:Show()
		SliceCommander:ChangeAnchor()
	end
end

do
	SLASH_RELOADUI1 = "/rl"
	SlashCmdList.RELOADUI = ReloadUI
	
	SLASH_SLICECOMMANDER1 = "/slicecommander"
	SLASH_SLICECOMMANDER2 = "/sc"
	SlashCmdList["SLICECOMMANDER"] = function(msg)
		InterfaceOptionsFrame_OpenToCategory("SliceCommander")
	end
end

function SliceCommander:SetPoisonTransparency(value)
	VTimerEnergy:SetAlpha(value/100)
	SC.BARS['MH']['obj']:SetAlpha(value/100)
	SC.BARS['OH']['obj']:SetAlpha(value/100)
end

function SliceCommander:TestBF()
	if SliceCommander_Save.BFBarShow then
		name = UnitAura("player", SC_SPELL_BF, nil, "PLAYER")
		if name and not SC.BARS['BF']['icon']:IsVisible() then
			SC.BARS['BF']['icon']:Show()
		elseif not name and SC.BARS['BF']['icon']:IsVisible() then
			SC.BARS['BF']['icon']:Hide()
		end
	else
		SC.BARS['BF']['icon']:Hide()
	end
end

function SliceCommander:TestDPCP()
	name, _, _, count, _, _, _, isMine = UnitDebuff("target", SC_SPELL_DP, nil, "PLAYER")
	if count == nil then
		count = 0
	end
	SliceCommander:CPColor(name, count, isMine)
end

function SliceCommander:Latency()
	SC.tNow = GetTime()
	if (SliceCommander_Save.PadLatency) then
		_, _, SC.lag = GetNetStats()
		SC.tNow = SC.tNow + (SC.lag*2/1000)
	end
end

function SliceCommander:Energy()
	VTimerEnergy:SetValue(UnitMana("player"))
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"))
	VTimerEnergyTxt:SetText(VTimerEnergy:GetValue())
		
	if SC.LastEnergy < SliceCommander_Save.Energy2 and UnitMana('player') >= SliceCommander_Save.Energy2 then
		SliceCommander:Sound("EnergySound2")
	elseif SC.LastEnergy < SliceCommander_Save.Energy1 and UnitMana('player') >= SliceCommander_Save.Energy1 then
		SliceCommander:Sound("EnergySound1")
	elseif SC.LastEnergy < SliceCommander_Save.Energy3 and UnitMana('player') >= SliceCommander_Save.Energy3 then
		SliceCommander:Sound("EnergySound3")
	end
	SC.LastEnergy = UnitMana('player')
	
	if UnitManaMax("player") == UnitMana('player') and UnitAffectingCombat("player")~=1 then
		if SliceCommander_Save.PoisonShow == true and SliceCommander_Save.PoisonTransparencyShow == true and ((SC.BARS['MH']['obj']:GetValue() ~= 0 and SC.BARS['MH']['obj']:GetValue() ~= nil) or (SC.BARS['OH']['obj']:GetValue() ~= 0 and SC.BARS['OH']['obj']:GetValue() ~= nil) ) then
			SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
		else
			SliceCommander:SetPoisonTransparency(SliceCommander_Save.EnergyTrans)
		end
	else
		SliceCommander:SetPoisonTransparency(SliceCommander_Save.FrameOpacity)
	end
end

function SliceCommander:OnUpdate()
	SliceCommander:Energy()--Update energy value and play sound if necessary
	SliceCommander:Latency()--Update timer reference and latency
	
	SliceCommander:PoisonBar()--Update Poisons Bar
	SliceCommander:TargetThreat()--Update Threat Bar
	
	RUP_AlertPending = SliceCommander:UpdateBar(SC.BARS['Rup'], SliceCommander_Save.RupBarShow, soundRup, RUP_AlertPending, 2, 2)--Update Rupture Bar	
	SND_AlertPending = SliceCommander:UpdateBar(SC.BARS['SnD'], SliceCommander_Save.SnDBarShow, soundSnd, SND_AlertPending, false, 1)--Update SnD Bar
	SliceCommander:UpdateBar(SC.BARS['REC'], SliceCommander_Save.RECBarShow, nil, nil, 3, 0)--Update Recuprate Bar
	SliceCommander:UpdateBar(SC.BARS['Gar'], SliceCommander_Save.GarBarShow, nil, nil, 3, 0)--Update Garrote Bar
	SliceCommander:UpdateBar(SC.BARS['KS'], SliceCommander_Save.KSBarShow, nil, nil, false, 0)--Update Kidney Shot Bar
	SliceCommander:UpdateBar(SC.BARS['CS'], SliceCommander_Save.CSBarShow, nil, nil, false, 0)--Update Cheap Shot Bar
	SliceCommander:UpdateBar(SC.BARS['DP'], SliceCommander_Save.DPBarShow, nil, nil, false, 0)--Update Deadly poison Bar
	SliceCommander:UpdateBar(SC.BARS['ENV'], SliceCommander_Save.EnvenomShow, nil, nil, false, 0)--Update Envenom Bar
	SliceCommander:UpdateBar(SC.BARS['VEN'], SliceCommander_Save.VenBarShow, nil, nil, false, 0)--Update Vendetta Bar
	SliceCommander:UpdateBar(SC.BARS['AR'], SliceCommander_Save.ARBarShow, nil, nil, false, 3)--Update Adrenaline rush Bar
	SliceCommander:AbilityCDBar(SC.BARS['VENCD'], SliceCommander_Save.VenBarShow)--Update Vendetta CD bar
	SliceCommander:AbilityCDBar(SC.BARS['ToT'], SliceCommander_Save.TotTBarShow)--Update ToT CD bar
	SliceCommander:AbilityCDBar(SC.BARS['ARCD'], SliceCommander_Save.ShowARCD)--Update Adrenaline rush CD bar
	SliceCommander:TestDPCP()--Update Combot point color
	SliceCommander:TestBF()--Update BF bar display
end